#!/usr/local/bin/perl

#extract url//place triples from univ.html
#except discarding documents with weird characters

$/ = '<li>' ; #read by list items

open(UNIV,"<univ.html") || die;
$header = <UNIV>;
while (<UNIV>) {
    next unless /<li>$/;
    tr/[\n\t ]/ /s;
    s/<\/dl>\s*<hr>//;
    if (($url,$fullname) = /<a\s*href=\"([^\"]*)\">(.*)<\/a>/i) {
	#skip ftp sites, names and places with weird characters
	next unless $url =~ /^http:/;
	next if $fullname =~ /\&[^\;]*\;/;
	$fullname =~ s/^\s+//; $fullname =~ s/\s+$//; 
	if (($name,$place) = $fullname =~ /(.*)\s+\-\s+(.*)/) {
	    $place =~ s/\((.*)\)/\1/;
	    ;
	} elsif (($name,$place) = $fullname =~ /(.*)\s+\((.*)\)\s*$/) {
	    $place =~ s/\((.*)\)/\1/;
	} else {
	    $name = $fullname;
	    $place = '';
	}
	if ((($pre,$post) = $name =~ /(.*)\,\s*(.*)/) && (! ($post =~ /the/i))) {
	    $name = $pre;
	    $place .= $post;
	}
	print "$name|$place|$url\n";
    }
}
close(AHA);
