#!/usr/local/bin/perl

#extract url/name/place triples from aha.html
#except discarding documents with weird characters

$/ = '' ; #read by paragraphs

open(AHA,"<aha.html") || die;
while (<AHA>) {
    tr/[\n\t ]/ /s;
    s/<\/dl>\s*<hr>//;
    if (($url,$name,$place) = /<dd><a\s*href=\"([^\"]*)\">(.*)<\/a>,(.*)/i) {
	#skip ftp sites, names and places with weird characters
	next unless $url =~ /^http:/;
	next if $name =~ /\&[^\;]*\;/;
	next if $place =~ /\&[^\;]*\;/;
	$place =~ s/^\s+//; $place =~ s/\s+$//; 
	$name =~ s/^\s+//; $name =~ s/\s+$//; 
	print "$name|$place|$url\n";
    }
}
close(AHA);
